diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
index 331864413..bf31e01a2 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
@@ -22,7 +22,7 @@ import org.slf4j.Logger;
 import org.useless.dragonfly.DisplayPos;
 import org.useless.dragonfly.data.block.BlockModelData;
 import org.useless.dragonfly.models.block.StaticBlockModel;
-import org.useless.dragonfly.models.block.mojang.StaticModelMojang;
+import org.useless.dragonfly.models.block.mojang.StaticBlockModelMojang;
 
 import java.io.InputStream;
 import java.io.InputStreamReader;
@@ -44,7 +44,7 @@ public class BlockModelMojangData implements BlockModelData {
     protected final static Gson gson = builder().create();
 
     protected static GsonBuilder builder() {
-        GsonBuilder builder = new GsonBuilder();
+        final GsonBuilder builder = new GsonBuilder();
         builder.setPrettyPrinting();
         builder.registerTypeAdapter(BlockModelMojangData.Builder.class, new BlockModelMojangData.Builder.Serializer());
         builder.registerTypeAdapter(Element.Builder.class, new Element.Builder.Serializer());
@@ -102,20 +102,20 @@ public class BlockModelMojangData implements BlockModelData {
     public final @Nullable List<@NotNull Element> elements;
 
     protected BlockModelMojangData(
-        @NotNull TexturePackList texturePackList,
-        @NotNull NamespaceID id,
-        @Nullable String parent,
-        boolean ambientOcclusion,
-        @Nullable Integer renderLayer,
-        @Nullable Map<@NotNull String, @NotNull DisplayPos> displayPositions,
-        @Nullable Map<@NotNull String, @NotNull String> textures,
-        @Nullable Map<@NotNull Direction, @NotNull Integer> particleIndices,
-        @Nullable List<@NotNull Element> elements)
+        @NotNull final TexturePackList texturePackList,
+        @NotNull final NamespaceID id,
+        @Nullable final String parent,
+        final boolean ambientOcclusion,
+        @Nullable final Integer renderLayer,
+        @Nullable final Map<@NotNull String, @NotNull DisplayPos> displayPositions,
+        @Nullable final Map<@NotNull String, @NotNull String> textures,
+        @Nullable final Map<@NotNull Direction, @NotNull Integer> particleIndices,
+        @Nullable final List<@NotNull Element> elements)
     {
         this.modelId = id;
         this.parent = parent;
         if (parent != null) {
-            BlockModelMojangData parentData = BlockModelMojangData.Cache.loadModelData(texturePackList, parent);
+            final BlockModelMojangData parentData = BlockModelMojangData.Cache.loadModelData(texturePackList, parent);
             this.ambientOcclusion = ambientOcclusion;
             if (parentData != null) {
                 this.displayPositions = new HashMap<>();
@@ -151,24 +151,24 @@ public class BlockModelMojangData implements BlockModelData {
 
     @Override
     public @NotNull NamespaceID modelId() {
-        return modelId;
+        return this.modelId;
     }
 
     @Override
     public @NotNull StaticBlockModel asModel() {
-        return new StaticModelMojang(this);
+        return new StaticBlockModelMojang(this);
     }
 
     @Override
     public String toString() {
         return "BlockModelMojangData{" +
-            "modelId=" + modelId +
-            ", parent='" + parent + '\'' +
-            ", ambientOcclusion=" + ambientOcclusion +
-            ", displayPositions=" + displayPositions +
-            ", textures=" + textures +
-            ", particleIndices=" + particleIndices +
-            ", elements=" + elements +
+            "modelId=" + this.modelId +
+            ", parent='" + this.parent + '\'' +
+            ", ambientOcclusion=" + this.ambientOcclusion +
+            ", displayPositions=" + this.displayPositions +
+            ", textures=" + this.textures +
+            ", particleIndices=" + this.particleIndices +
+            ", elements=" + this.elements +
             '}';
     }
 
@@ -182,112 +182,112 @@ public class BlockModelMojangData implements BlockModelData {
         protected @Nullable Map<@NotNull Direction, @NotNull Integer> particleIndices = null;
         protected @Nullable List<Element. @NotNull Builder> elements = null;
 
-        public @NotNull Builder setParent(@Nullable String parent) {
+        public @NotNull Builder setParent(@Nullable final String parent) {
             this.parent = parent;
             return this;
         }
 
-        public @NotNull Builder setAO(boolean ao) {
+        public @NotNull Builder setAO(final boolean ao) {
             this.ambientOcclusion = ao;
             return this;
         }
 
-        public @NotNull Builder setRenderLayer(int renderLayer) {
+        public @NotNull Builder setRenderLayer(final int renderLayer) {
             this.renderLayer = renderLayer;
             return this;
         }
 
-        public @NotNull Builder setDisplay(@NotNull String id, @Nullable DisplayPos displayPos) {
-            if (displayPos == null && displayPosMap != null) {
-                displayPosMap.remove(id);
+        public @NotNull Builder setDisplay(@NotNull final String id, @Nullable final DisplayPos displayPos) {
+            if (displayPos == null && this.displayPosMap != null) {
+                this.displayPosMap.remove(id);
             } else if (displayPos != null) {
                 prepareDisplayPosMap().put(id, displayPos);
             }
             return this;
         }
 
-        public @NotNull Builder setTexture(@NotNull String textureVariable, @NotNull String textureSymbol) {
+        public @NotNull Builder setTexture(@NotNull final String textureVariable, @NotNull final String textureSymbol) {
             prepareTextureMap().put(textureVariable, textureSymbol);
             return this;
         }
 
-        public @NotNull Builder setParticleIndex(@NotNull Direction direction, int index) {
+        public @NotNull Builder setParticleIndex(@NotNull final Direction direction, final int index) {
             prepareParticleIndicesMap().put(direction, index);
             return this;
         }
 
-        public @NotNull Builder addElement(Element. @NotNull Builder elementBuilder) {
+        public @NotNull Builder addElement(final Element. @NotNull Builder elementBuilder) {
             prepareElementsList().add(elementBuilder);
             return this;
         }
 
         private @NotNull Map<@NotNull String, @NotNull DisplayPos> prepareDisplayPosMap() {
-            if (displayPosMap == null) displayPosMap = new HashMap<>();
-            return displayPosMap;
+            if (this.displayPosMap == null) this.displayPosMap = new HashMap<>();
+            return this.displayPosMap;
         }
 
         private @NotNull Map<@NotNull String, @NotNull String> prepareTextureMap() {
-            if (textures == null) textures = new HashMap<>();
-            return textures;
+            if (this.textures == null) this.textures = new HashMap<>();
+            return this.textures;
         }
 
         private @NotNull Map<@NotNull Direction, @NotNull Integer> prepareParticleIndicesMap() {
-            if (particleIndices == null) particleIndices = new HashMap<>();
-            return particleIndices;
+            if (this.particleIndices == null) this.particleIndices = new HashMap<>();
+            return this.particleIndices;
         }
 
         private @NotNull List<Element. @NotNull Builder> prepareElementsList() {
-            if (elements == null) elements = new ArrayList<>();
-            return elements;
+            if (this.elements == null) this.elements = new ArrayList<>();
+            return this.elements;
         }
 
-        protected @NotNull BlockModelMojangData build(@NotNull TexturePackList texturePackList, @NotNull String id) {
+        protected @NotNull BlockModelMojangData build(@NotNull final TexturePackList texturePackList, @NotNull String id) {
             if (!id.contains(":")) {
                 id = DEFAULT_NAMESPACE + ":" + id;
             }
             List<Element> elementList = null;
-            if (elements != null) {
+            if (this.elements != null) {
                 elementList = new ArrayList<>();
-                for (Element.Builder b : elements) {
+                for (final Element.Builder b : this.elements) {
                     elementList.add(b.build());
                 }
             }
             try {
-                return new BlockModelMojangData(texturePackList, new NamespaceID(id), parent, ambientOcclusion, renderLayer, displayPosMap, textures, particleIndices, elementList);
-            } catch (HardIllegalArgumentException e) {
+                return new BlockModelMojangData(texturePackList, new NamespaceID(id), this.parent, this.ambientOcclusion, this.renderLayer, this.displayPosMap, this.textures, this.particleIndices, elementList);
+            } catch (final HardIllegalArgumentException e) {
                 throw new IllegalArgumentException(e);
             }
         }
 
         public static class Serializer implements JsonSerializer<BlockModelMojangData.Builder>, JsonDeserializer<BlockModelMojangData.Builder> {
             @Override
-            public BlockModelMojangData.Builder deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
-                JsonObject object = json.getAsJsonObject();
-                BlockModelMojangData.Builder dataBuilder = new BlockModelMojangData.Builder();
+            public BlockModelMojangData.Builder deserialize(final JsonElement json, final Type typeOfT, final JsonDeserializationContext context) throws JsonParseException {
+                final JsonObject object = json.getAsJsonObject();
+                final BlockModelMojangData.Builder dataBuilder = new BlockModelMojangData.Builder();
                 if (object.has("parent")) dataBuilder.setParent(object.get("parent").getAsString());
                 if (object.has("ambientocclusion")) dataBuilder.setAO(object.get("ambientocclusion").getAsBoolean());
                 if (object.has("renderlayer")) dataBuilder.setRenderLayer(object.get("renderlayer").getAsInt());
                 if (object.has("display")) {
-                    JsonObject display = object.getAsJsonObject("display");
-                    for (Map.Entry<String, JsonElement> e : display.entrySet()) {
+                    final JsonObject display = object.getAsJsonObject("display");
+                    for (final Map.Entry<String, JsonElement> e : display.entrySet()) {
                         dataBuilder.setDisplay(e.getKey(), context.deserialize(e.getValue(), DisplayPos.class));
                     }
                 }
                 if (object.has("textures")) {
-                    JsonObject textures = object.getAsJsonObject("textures");
-                    for (Map.Entry<String, JsonElement> e : textures.entrySet()) {
+                    final JsonObject textures = object.getAsJsonObject("textures");
+                    for (final Map.Entry<String, JsonElement> e : textures.entrySet()) {
                         dataBuilder.setTexture(e.getKey(), e.getValue().getAsString());
                     }
                 }
                 if (object.has("elements")) {
-                    JsonArray elements = object.getAsJsonArray("elements");
-                    for (JsonElement e : elements) {
+                    final JsonArray elements = object.getAsJsonArray("elements");
+                    for (final JsonElement e : elements) {
                         dataBuilder.addElement(context.deserialize(e, Element.Builder.class));
                     }
                 }
                 if (object.has("particles")) {
-                    JsonObject textures = object.getAsJsonObject("particles");
-                    for (Map.Entry<String, JsonElement> e : textures.entrySet()) {
+                    final JsonObject textures = object.getAsJsonObject("particles");
+                    for (final Map.Entry<String, JsonElement> e : textures.entrySet()) {
                         dataBuilder.setParticleIndex(Direction.valueOf(e.getKey().toUpperCase(Locale.ROOT)), e.getValue().getAsInt());
                     }
                 }
@@ -296,7 +296,7 @@ public class BlockModelMojangData implements BlockModelData {
             }
 
             @Override
-            public JsonElement serialize(BlockModelMojangData.Builder src, Type typeOfSrc, JsonSerializationContext context) {
+            public JsonElement serialize(final BlockModelMojangData.Builder src, final Type typeOfSrc, final JsonSerializationContext context) {
                 throw new UnsupportedOperationException();
             }
         }
@@ -308,37 +308,37 @@ public class BlockModelMojangData implements BlockModelData {
 
         protected static final String RESOURCE_PATH = "/assets/%s/models/%s.json";
 
-        public static @Nullable BlockModelMojangData loadModelData(@NotNull TexturePackList texturePackList, @NotNull NamespaceID id) {
-            String s = id.toString();
+        public static @Nullable BlockModelMojangData loadModelData(@NotNull final TexturePackList texturePackList, @NotNull final NamespaceID id) {
+            final String s = id.toString();
             if (modelDataCache.containsKey(s)) return modelDataCache.get(s);
-            BlockModelMojangData.Builder data = loadFromStream(texturePackList.getResourceAsStream(String.format(RESOURCE_PATH, id.namespace, id.value)));
+            final BlockModelMojangData.Builder data = loadFromStream(texturePackList.getResourceAsStream(String.format(RESOURCE_PATH, id.namespace, id.value)));
             if (data == null) {
                 LOGGER.error("Could not locate block model data for id '{}'!", id);
                 return null;
             }
-            BlockModelMojangData model = data.build(texturePackList, id.toString());
+            final BlockModelMojangData model = data.build(texturePackList, id.toString());
             modelDataCache.put(model.modelId().toString(), model);
             return model;
         }
-        public static @Nullable BlockModelMojangData loadModelData(@NotNull TexturePackList texturePackList, @NotNull String id) {
-            String namespace;
-            String value;
+        public static @Nullable BlockModelMojangData loadModelData(@NotNull final TexturePackList texturePackList, @NotNull final String id) {
+            final String namespace;
+            final String value;
             if (!id.contains(":")) {
                 namespace = DEFAULT_NAMESPACE;
                 value = id;
             } else {
-                String[] strings = id.split(":");
+                final String[] strings = id.split(":");
                 if (strings.length != 2) throw new  IllegalArgumentException("Block model id '" + id + "' cannot have more then 1 ':' character!");
                 namespace = strings[0];
                 value = strings[1];
             }
             if (modelDataCache.containsKey(id)) return modelDataCache.get(id);
-            BlockModelMojangData.Builder data = loadFromStream(texturePackList.getResourceAsStream(String.format(RESOURCE_PATH, namespace, value)));
+            final BlockModelMojangData.Builder data = loadFromStream(texturePackList.getResourceAsStream(String.format(RESOURCE_PATH, namespace, value)));
             if (data == null) {
                 LOGGER.error("Could not locate block model data for id '{}'!", id);
                 return null;
             }
-            BlockModelMojangData model = data.build(texturePackList, namespace + ":" + value);
+            final BlockModelMojangData model = data.build(texturePackList, namespace + ":" + value);
             modelDataCache.put(model.modelId().toString(), model);
             return model;
         }
@@ -347,7 +347,7 @@ public class BlockModelMojangData implements BlockModelData {
             modelDataCache.clear();
         }
 
-        protected static @Nullable BlockModelMojangData.Builder loadFromStream(@Nullable InputStream stream) {
+        protected static @Nullable BlockModelMojangData.Builder loadFromStream(@Nullable final InputStream stream) {
             if (stream == null) return null;
             return gson.fromJson(new JsonReader(new InputStreamReader(stream)), BlockModelMojangData.Builder.class);
         }
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/entity/EntityModelData.java b/game/client/src/main/java/org/useless/dragonfly/data/entity/EntityModelData.java
new file mode 100644
index 000000000..8ac337c9c
--- /dev/null
+++ b/game/client/src/main/java/org/useless/dragonfly/data/entity/EntityModelData.java
@@ -0,0 +1,9 @@
+package org.useless.dragonfly.data.entity;
+
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.entity.StaticEntityModel;
+
+public interface EntityModelData {
+    @NotNull String modelId();
+    @NotNull StaticEntityModel asModel(double inflation);
+}
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/Bone.java b/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/Bone.java
new file mode 100644
index 000000000..1a4970081
--- /dev/null
+++ b/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/Bone.java
@@ -0,0 +1,141 @@
+package org.useless.dragonfly.data.entity.mojang;
+
+import com.google.gson.JsonArray;
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.util.GsonHelper;
+
+import java.lang.reflect.Type;
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.List;
+
+public class Bone {
+    public final @NotNull String name;
+    public final @Nullable String parent;
+    public final double @NotNull [] pivot;
+    public final double @NotNull [] rotation;
+    public final @NotNull Cube @NotNull [] cubes;
+    public final double inflate;
+
+    protected Bone(
+        @NotNull final String name,
+        @Nullable final String parent,
+        final double @NotNull [] pivot,
+        final double @NotNull [] rotation,
+        final double inflate,
+        @NotNull final Collection<Cube.Builder> cubes) {
+        this.name = name;
+        this.parent = parent;
+        this.pivot = pivot;
+        this.rotation = rotation;
+        this.cubes = new Cube[cubes.size()];
+        this.inflate = inflate;
+
+        int i = 0;
+        for (final Cube.Builder builder : cubes) {
+            this.cubes[i] = builder.build();
+            i++;
+        }
+    }
+
+    public static class Builder {
+        private final @NotNull String name;
+        private @Nullable String parent;
+        private final double @NotNull [] pivot;
+        private final double @NotNull [] rotation;
+        private double inflate;
+        private final @NotNull List<Cube. @NotNull  Builder> cubes = new ArrayList<>();
+        private boolean mirror;
+        public Builder(@NotNull final String name) {
+            this.name = name;
+            this.parent = null;
+            this.pivot = new double[]{0, 0, 0};
+            this.rotation = new double[]{0, 0, 0};
+            this.inflate = 0;
+            this.mirror = false;
+        }
+
+        public @NotNull Builder setParent(final @NotNull String parent) {
+            this.parent = parent;
+            return this;
+        }
+
+        public @NotNull Builder setPivot(final double x, final double y, final double z) {
+            this.pivot[0] = x;
+            this.pivot[1] = y;
+            this.pivot[2] = z;
+            return this;
+        }
+
+        public @NotNull Builder setRotation(final double x, final double y, final double z) {
+            this.rotation[0] = x;
+            this.rotation[1] = y;
+            this.rotation[2] = z;
+            return this;
+        }
+
+        public @NotNull Builder setInflation(final double inflation) {
+            this.inflate = inflation;
+            return this;
+        }
+
+        public @NotNull Builder setMirror(final boolean mirror) {
+            this.mirror = mirror;
+            return this;
+        }
+
+        public @NotNull Builder addCube(final @NotNull Cube.Builder cube) {
+            this.cubes.add(cube);
+            return this;
+        }
+
+        protected @NotNull Bone build() {
+            if (this.mirror) {
+                for (final Cube.Builder builder : this.cubes) {
+                    builder.setMirror();
+                }
+            }
+            return new Bone(this.name, this.parent, this.pivot, this.rotation, this.inflate, this.cubes);
+        }
+
+        public static class Serializer implements JsonSerializer<Bone.Builder>, JsonDeserializer<Bone.Builder> {
+
+            @Override
+            public Builder deserialize(final JsonElement json, final Type typeOfT, final JsonDeserializationContext context) throws JsonParseException {
+                final JsonObject object = json.getAsJsonObject();
+                final Builder builder = new Builder(object.get("name").getAsString());
+                if (object.has("parent")) builder.setParent(object.get("parent").getAsString());
+                if (object.has("pivot")) {
+                    final double[] pivot = GsonHelper.getAsDoubleArray(object.get("pivot"), 3);
+                    builder.setPivot(pivot[0], pivot[1], pivot[2]);
+                }
+                if (object.has("rotation")) {
+                    final double[] rotation = GsonHelper.getAsDoubleArray(object.get("rotation"), 3);
+                    builder.setRotation(rotation[0], rotation[1], rotation[2]);
+                }
+                if (object.has("inflate")) builder.setInflation(object.get("inflate").getAsDouble());
+                if (object.has("mirror")) builder.setMirror(object.get("mirror").getAsBoolean());
+                if (object.has("cubes")) {
+                    final JsonArray cubes = object.getAsJsonArray("cubes");
+                    for (final JsonElement e : cubes) {
+                        builder.addCube(context.deserialize(e, Cube.Builder.class));
+                    }
+                }
+                return builder;
+            }
+
+            @Override
+            public JsonElement serialize(final Builder src, final Type typeOfSrc, final JsonSerializationContext context) {
+                throw new UnsupportedOperationException();
+            }
+        }
+    }
+}
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/Cube.java b/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/Cube.java
new file mode 100644
index 000000000..1a218ddfe
--- /dev/null
+++ b/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/Cube.java
@@ -0,0 +1,180 @@
+package org.useless.dragonfly.data.entity.mojang;
+
+import com.google.gson.JsonDeserializationContext;
+import com.google.gson.JsonDeserializer;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParseException;
+import com.google.gson.JsonSerializationContext;
+import com.google.gson.JsonSerializer;
+import net.minecraft.core.util.helper.Direction;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.util.GsonHelper;
+
+import java.lang.reflect.Type;
+import java.util.Locale;
+import java.util.Map;
+
+public class Cube {
+    public final double @NotNull [] origin;
+    public final double @NotNull [] size;
+    public final @Nullable Face @NotNull [] faces;
+    public final double inflate;
+    public final double @NotNull [] pivot;
+    public final double @Nullable [] rotation;
+
+    protected Cube(final double @NotNull [] origin, final double @NotNull [] size, final @Nullable Face.Builder @NotNull [] faces, final double inflate, final double @NotNull [] pivot, final double @Nullable [] rotation) {
+        this.origin = origin;
+        this.size = size;
+        this.pivot = pivot;
+        this.rotation = rotation;
+        this.faces = new Face[6];
+        for (int i = 0; i < 6; i++) {
+            final Face.Builder builder = faces[i];
+            if (builder == null) continue;
+            this.faces[i] = builder.build();
+        }
+        this.inflate = inflate;
+    }
+
+    public static class Builder {
+        private final double @NotNull [] origin;
+        private final double @NotNull [] size;
+        private final @Nullable Face.Builder @NotNull [] faces;
+        private double inflate;
+        private final double @NotNull [] pivot;
+        private double @Nullable [] rotation = null;
+        private boolean mirror;
+
+        public Builder(
+            final double oX, final double oY, final double oZ,
+            final double sX, final double sY, final double sZ
+        ) {
+            this.origin = new double[]{oX, oY, oZ};
+            this.size = new double[]{sX, sY, sZ};
+            this.faces = new Face.Builder[6];
+            this.inflate = 0;
+            this.pivot = new double[]{0, 0, 0};
+        }
+
+        public Builder(
+            final double @NotNull [] origin,
+            final double @NotNull [] size
+        ) {
+            this.origin = origin;
+            this.size = size;
+            this.faces = new Face.Builder[6];
+            this.inflate = 0;
+            this.pivot = new double[]{0, 0, 0};
+        }
+
+        public @NotNull Builder setFaces(final double u, final double v) {
+            final double sizeX = this.size[0];
+            final double sizeY = this.size[1];
+            final double sizeZ = this.size[2];
+            this.faces[Direction.UP.getId()] = new Face.Builder(u + sizeZ, v, sizeX, sizeZ);
+            this.faces[Direction.DOWN.getId()] = new Face.Builder(u + sizeX + sizeZ, v + sizeZ, sizeX, -sizeZ);
+            this.faces[Direction.NORTH.getId()] = new Face.Builder(u + sizeZ, v + sizeZ, sizeX, sizeY);
+            this.faces[Direction.SOUTH.getId()] = new Face.Builder(u + (sizeZ * 2) + sizeX, v + sizeZ, sizeX, sizeY);
+            this.faces[Direction.EAST.getId()] = new Face.Builder(u, v + sizeZ, sizeZ, sizeY);
+            this.faces[Direction.WEST.getId()] = new Face.Builder(u + sizeZ + sizeX, v + sizeZ, sizeZ, sizeY);
+            return this;
+        }
+
+        public @NotNull Builder setFace(final @NotNull Direction direction, final @Nullable Face.Builder builder) {
+            this.faces[direction.getId()] = builder;
+            return this;
+        }
+
+        public @NotNull Builder setInflation(final double inflation) {
+            this.inflate = inflation;
+            return this;
+        }
+
+        public @NotNull Builder setPivot(final double x, final double y, final double z) {
+            this.pivot[0] = x;
+            this.pivot[1] = y;
+            this.pivot[2] = z;
+            return this;
+        }
+
+        public @NotNull Builder setRotation(final double x, final double y, final double z) {
+            if (this.rotation == null) this.rotation = new double[3];
+            this.rotation[0] = x;
+            this.rotation[1] = y;
+            this.rotation[2] = z;
+            return this;
+        }
+
+        public @NotNull Builder setMirror() {
+            this.mirror = !this.mirror;
+            return this;
+        }
+
+        protected void mirror() {
+            final Face.Builder west = this.faces[Direction.WEST.getId()];
+            this.faces[Direction.WEST.getId()] = this.faces[Direction.EAST.getId()];
+            this.faces[Direction.EAST.getId()] = west;
+            for (final Face.Builder builder : this.faces) {
+                if (builder == null) continue;
+                builder.setMirror();
+            }
+
+        }
+
+        protected @NotNull Cube build()
+        {
+            if (this.mirror) {
+                mirror();
+            }
+            return new Cube(this.origin, this.size, this.faces, this.inflate, this.pivot, this.rotation);
+        }
+
+        public static class Serializer implements JsonSerializer<Cube.Builder>, JsonDeserializer<Cube.Builder> {
+
+            @Override
+            public Builder deserialize(final JsonElement json, final Type typeOfT, final JsonDeserializationContext context) throws JsonParseException {
+                final JsonObject o = json.getAsJsonObject();
+                final double[] origin = GsonHelper.getAsDoubleArray(o.getAsJsonArray("origin"), 3);
+                final double[] size = GsonHelper.getAsDoubleArray(o.getAsJsonArray("size"), 3);
+                final Builder builder = new Builder(origin, size);
+
+                final JsonElement uvElement = o.get("uv");
+                if (uvElement.isJsonArray()) {
+                    final double[] uv = GsonHelper.getAsDoubleArray(uvElement, 2);
+                    builder.setFaces(uv[0], uv[1]);
+                } else if (uvElement.isJsonObject()) {
+                    final JsonObject uvObject = uvElement.getAsJsonObject();
+                    for (final Map.Entry<String, JsonElement> faceEntries : uvObject.entrySet()) {
+                        final Direction direction = Direction.valueOf(faceEntries.getKey().toUpperCase(Locale.ROOT));
+                        builder.setFace(direction, context.deserialize(faceEntries.getValue(), Face.Builder.class));
+                    }
+                }
+
+                if (o.has("inflate")) builder.setInflation(o.get("inflate").getAsDouble());
+
+                if (o.has("pivot")) {
+                    final double[] pivot = GsonHelper.getAsDoubleArray(o.get("pivot"), 3);
+                    builder.setPivot(pivot[0], pivot[1], pivot[2]);
+                }
+
+                if (o.has("rotation")) {
+                    final double[] rotation = GsonHelper.getAsDoubleArray(o.get("rotation"), 3);
+                    builder.setRotation(rotation[0], rotation[1], rotation[2]);
+                }
+
+                if (o.has("mirror") && o.get("mirror").getAsBoolean()) {
+                    builder.setMirror();
+                }
+
+                return builder;
+            }
+
+            @Override
+            public JsonElement serialize(final Builder src, final Type typeOfSrc, final JsonSerializationContext context) {
+                throw new UnsupportedOperationException();
+            }
+        }
+    }
+}
